import Qt 4.7
import "../../imports/colibri"

Rectangle {
    id: xaqmlDatePicker1
    width: 250
    height: 270

    color: "transparent"

    property string currentMonth : "initM"
    property string currentYear : "initY"

    property int theDay : 3
    property int theMonth : 7
    property int theYear : 2010

    property int displayMonth : 7
    property int displayYear : 2010

    property bool enabled: true

    property string theTime: "00:00:00"

    signal dateSelected()

//    gradient: Gradient {
//        GradientStop { position: 0; color: "#222222" }
//        GradientStop { position: 0.5; color: "#3f3b3c" }
//        GradientStop { position: 1; color: "#222222" }
//    }

//    radius: 20

    function getCalendarDate() {
       var months = new Array(13);
        months[0]  = qsTr("January");
       months[1]  = qsTr("February");
       months[2]  = qsTr("March");
       months[3]  = qsTr("April");
       months[4]  = qsTr("May");
       months[5]  = qsTr("June");
       months[6]  = qsTr("July");
       months[7]  = qsTr("August");
       months[8]  = qsTr("September");
       months[9]  = qsTr("October");
       months[10] = qsTr("November");
       months[11] = qsTr("December");
       var now         = new Date();
       var monthnumber = now.getMonth();
       var monthname   = months[monthnumber];
       var monthday    = now.getDate();
       var year        = now.getYear();
       if(year < 2000) { year = year + 1900; }
       var dateString = monthname +
                        ' ' +
                        monthday +
                        ', ' +
                        year;
       return dateString;
    } // function getCalendarDate()

    function getClockTime() {
       var now    = new Date();
       var hour   = now.getHours();
       var minute = now.getMinutes();
       var second = now.getSeconds();

//       var ap = "AM";
//       if (hour   > 11) { ap = "PM";             }
//       if (hour   > 12) { hour = hour - 12;      }
//       if (hour   == 0) { hour = 12;             }

       if (hour   < 10) { hour   = "0" + hour;   }
       if (minute < 10) { minute = "0" + minute; }
       if (second < 10) { second = "0" + second; }
       //var timeString = hour + ':' + minute + ':' + second + " " + ap;
       var timeString = hour + ":" + minute + ":" + second;

       return timeString;
    } // function getClockTime()

    function zeroPad(num,count) {
        var numZeropad = num + '';
        while(numZeropad.length < count) {
            numZeropad = "0" + numZeropad;
        }
        return numZeropad;
    }

    function buildCal(m, y){
        //var mn=['January','February','March','April','May','June','July','August','September','October','November','December'];
        var mn = new Array(12);
        mn[0]  = qsTr("January");
        mn[1]  = qsTr("February");
        mn[2]  = qsTr("March");
        mn[3]  = qsTr("April");
        mn[4]  = qsTr("May");
        mn[5]  = qsTr("June");
        mn[6]  = qsTr("July");
        mn[7]  = qsTr("August");
        mn[8]  = qsTr("September");
        mn[9]  = qsTr("October");
        mn[10] = qsTr("November");
        mn[11] = qsTr("December");
        var dim=[31,0,31,30,31,30,31,31,30,31,30,31];

        var oD = new Date(y, m-1, 1); //DD replaced line to fix date bug when current day is 31st
        oD.od=oD.getDay()+1; //DD replaced line to fix date bug when current day is 31st

        var todaydate=new Date() //DD added
        var scanfortoday=(y==todaydate.getFullYear() && m==todaydate.getMonth()+1)? todaydate.getDate() : 0 //DD added

        var selectiondate=new Date(xaqmlDatePicker1.theYear, xaqmlDatePicker1.theMonth-1, xaqmlDatePicker1.theDay)
        var scanforselection = 0

        if (xaqmlDatePicker1.enabled) {
            scanforselection =(y==selectiondate.getFullYear() && m==selectiondate.getMonth()+1)? selectiondate.getDate() : 0 //DD added
        }

        dim[1]=(((oD.getFullYear()%100!=0)&&(oD.getFullYear()%4==0))||(oD.getFullYear()%400==0))?29:28;

        xaqmlDatePicker1.currentMonth = mn[m-1];
        xaqmlDatePicker1.currentYear = y

        xlwd1.operation = qsTr("Su")
        xlwd2.operation = qsTr("Mo")
        xlwd3.operation = qsTr("Tu")
        xlwd4.operation = qsTr("We")
        xlwd5.operation = qsTr("Th")
        xlwd6.operation = qsTr("Fr")
        xlwd7.operation = qsTr("Sa")

        var buttons = [xld01, xld02, xld03, xld04, xld05, xld06, xld07, xld11, xld12, xld13, xld14, xld15, xld16, xld17,
                       xld21, xld22, xld23, xld24, xld25, xld26, xld27, xld31, xld32, xld33, xld34, xld35, xld36, xld37,
                       xld41, xld42, xld43, xld44, xld45, xld46, xld47, xld51, xld52, xld53, xld54, xld55, xld56, xld57]

        var i
        for(i=1; i<=42; i++) {
            var x=((i-oD.od>=0)&&(i-oD.od<dim[m-1]))? i-oD.od+1 : '';

            //console.debug("next value:" + x + " selected:" + scanforselection + " today:" + scanfortoday)

            if (x != '') {
                buttons[i-1].operation = x
                buttons[i-1].enabled = true
                buttons[i-1].opcode = "d";

                if (scanfortoday != 0 && x==scanfortoday) buttons[i-1].framed = true
                else buttons[i-1].framed = false

                if (scanforselection != 0 && x==scanforselection) buttons[i-1].selected = true
                else buttons[i-1].selected = false

            } else {
                buttons[i-1].operation = ""
                buttons[i-1].enabled = false
                buttons[i-1].selected = false
                buttons[i-1].framed = false
                buttons[i-1].opcode = "";
            }
        }
    }

    function buildClock() {
//        console.debug("buildClock");

        var USClock = true

        var scanforhourselection = -1;
        var scanforminuteselection = -1;

        if (xaqmlDatePicker1.enabled) {
            if (theTime != "") {
                scanforhourselection = parseInt(theTime.substr(0,2), 10);
                scanforminuteselection = Math.floor(parseInt(theTime.substr(3,2), 10) / 5);

//                console.debug("SCAN FOR " + scanforhourselection + " h AND " + scanforminuteselection + " m in " + theTime)
            }
        }

        var buttons = [xlt01, xlt02, xlt03, xlt04, xlt05, xlt06,
                       xlt11, xlt12, xlt13, xlt14, xlt15, xlt16,
                       xlt21, xlt22, xlt23, xlt24, xlt25, xlt26,
                       xlt31, xlt32, xlt33, xlt34, xlt35, xlt36];

        var i
        for(i=0; i<=23; i++) {
            buttons[i].enabled = true;
            buttons[i].framed = false;

            if (scanforhourselection == i) buttons[i].selected = true;
            else buttons[i].selected = false;

            if (USClock) {
                var hour

                if (i >= 12) {
                    buttons[i].opcode = "p";
                    hour = i-12;
                } else {
                    buttons[i].opcode = "a";
                    hour = i;
                }

                if (hour === 0) hour = 12;

                buttons[i].operation = hour;

            } else {
                buttons[i].operation = i;
                buttons[i].opcode = "h";
            }
        }

        var minuteButtons = [xlm01, xlm11, xlm02, xlm12, xlm03, xlm13, xlm04, xlm14, xlm05, xlm15, xlm06, xlm16];

        for (i=1; i<=12; i++) {
            minuteButtons[i-1].operation = (i-1)*5;
            minuteButtons[i-1].enabled = true;
            minuteButtons[i-1].framed = false;
            minuteButtons[i-1].opcode = "m";

            if (scanforminuteselection === i-1) minuteButtons[i-1].selected = true;
            else minuteButtons[i-1].selected = false;
        }
    }

    function loadNow() {
//        console.debug("<< loadnow()")
        var todaydate = new Date();

//        theMonth = todaydate.getMonth()+1 //get current month (1-12)
//        theYear = todaydate.getFullYear() //get current year
//        theDay = todaydate.getDate() // get current date

//        theTime = getClockTime()
//        //timeInput.text = theTime

//        loadSelectedMonth()
//        loadSelectedTime();

        displayMonth = todaydate.getMonth()+1 //get current month (1-12)
        displayYear = todaydate.getFullYear() //get current year

        loadMonth(displayMonth, displayYear)
    }

    function loadMonth(m, y) {
        buildCal(m, y);
    }

    function loadSelectedMonth() {
        if (theMonth <= 12) {
            buildCal(theMonth, theYear);
            displayMonth = theMonth
            displayYear = theYear
        } else {
//            xaqmlDatePicker1.enabled = false
            onOffBoxSelector.switchOn = false
            //onOffBox.applySwitchSelection()
        }
    }

    function loadSelectedTime() {
//        console.debug("loadSelectedTime:" + theTime)
//        console.debug("hours:" + theTime.substring(0,2))
//        console.debug("minutes:" + theTime.substring(3,5))

//        xaTimePicker.setHours(theTime.substring(0,2))
//        xaTimePicker.setMinutes(theTime.substring(3,5))
        buildClock();
    }

    function doOp(opcode, operation) {
//        console.debug("<< doOp " + operation + " with opcode " + opcode)

        //var newDTS = zeroPad(theYear, 4) + "-" + zeroPad(theMonth, 2) + "-" + zeroPad(theDay, 2);
//        var newDTS = zeroPad(displayYear, 4) + "-" + zeroPad(displayMonth, 2) + "-" + zeroPad(theDay, 2);
//        newDTS += " " + zeroPad(theTime.substring(0,2), 2) + ":" + zeroPad(theTime.substring(3,5), 2) + ":00";
//        console.debug("<< before: " + newDTS)

        onOffBoxSelector.switchOn = true
        onOffBox.applySwitchSelection()

        if (opcode === "d") {
            theDay = operation

        } else if (opcode === "h") {
            theTime = zeroPad(parseInt(operation), 2) + ":" + theTime.substr(3,2) + ":00";

        } else if (opcode === "a") {
            var hour = parseInt(operation);
            if (hour === 12) hour = 0;

            theTime = zeroPad(hour, 2) + ":" + theTime.substr(3,2) + ":00";

        } else if (opcode === "p") {
            var hour = parseInt(operation);
            if (hour != 12) hour += 12;

            theTime = zeroPad(hour, 2) + ":" + theTime.substr(3,2) + ":00";

        } else if (opcode === "m") {
            theTime = theTime.substr(0,2) + ":" + zeroPad(parseInt(operation), 2) + ":00";

        }

        dateSelected()

//        newDTS = zeroPad(theYear, 4) + "-" + zeroPad(theMonth, 2) + "-" + zeroPad(theDay, 2);
//        newDTS += " " + zeroPad(theTime.substring(0,2), 2) + ":" + zeroPad(theTime.substring(3,5), 2) + ":00";
//        console.debug("<< after: " + newDTS)
    }

//    onTheMonthChanged: loadSelectedMonth()
//    onTheYearChanged: loadSelectedMonth()
//    onTheDayChanged: loadSelectedMonth()
//    onTheTimeChanged: loadSelectedTime()

    onEnabledChanged: {
//        console.debug("<< onEnabledChanged")

        if (xaqmlDatePicker1.enabled) {
            xaTimePicker.enabled = true;
            onOffBoxSelector.switchOn = true

        } else {
            xaTimePicker.enabled = false
            onOffBoxSelector.switchOn = false
        }
    }


//    Component.onCompleted: loadNow();

    Item {
        id: onOffBox
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top

        Rectangle {
            id: flaggingOnOffControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            //color: "black"
            color: "transparent"

            XAOnOffSelector2 {
                id: onOffBoxSelector
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.top: parent.top
                anchors.topMargin: 0

                labelText: qsTr("Enabled:")
                switchOn: xaqmlDatePicker1.enabled

                onSwitchChanged: {
//                    console.debug("QML++ switch changed")

                    onOffBox.applySwitchSelection();
                }
            }
        }

        function applySwitchSelection() {
            if (onOffBoxSelector.switchOn) {
                xaqmlDatePicker1.enabled = true
                xaTimePicker.enabled = true;
                dateSelected()
//                loadNow();
//                console.debug("SWITCH IS ON")
//                loadSelectedMonth();

            } else {
                xaqmlDatePicker1.enabled = false
                xaTimePicker.enabled = false
                dateSelected()
                buildCal(theMonth, theYear);
                buildClock();
//                console.debug("SWITCH IS OFF")
            }
        }
    }


    XAHDivisionLine {
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 40
    }

    Item {
        id: calendarBox
        anchors.left: parent.left
        anchors.leftMargin: 15
        anchors.right: parent.right
        anchors.rightMargin: 15
        anchors.top: parent.top
        anchors.topMargin: 45
        //anchors.bottom: parent.bottom
        height: 170
        //width: 150

        //
        // calendar header / month up and down boxes
        //

        Item {
            id: dateNavBox
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            height: 24
            anchors.leftMargin: 10; anchors.rightMargin: 10

            Item {
                id: dateNavLeft
                anchors.left: parent.left
                y: 4
                width: 12
                height: 12

                Image {
                    id: dateNavLeftImage
                    anchors.fill: parent
                    smooth: true

                    source: "pics/CalendarBackButton12px.png"
                }

                MouseArea {
                    id: dateNavLeftMouseArea
                    anchors.fill: parent

                    onClicked: {
//                        if (theMonth > 1) theMonth--
//                        else {
//                            theYear--;
//                            theMonth = 12;
//                        }
//                        console.debug("Month:" + theMonth + " Year:" + theYear)
//                        loadSelectedMonth();

                        if (displayMonth > 1) displayMonth--
                        else {
                            displayYear--;
                            displayMonth = 12;
                        }
//                        console.debug("Month:" + theMonth + " Year:" + theYear)
                        loadMonth(displayMonth, displayYear);
                    }
                }
            }

            Item {
                id: dateNavToday
                anchors.left: parent.left
                anchors.leftMargin: 14
                y: 4
                width: 12
                height: 12

                Image {
                    id: dateNavTodayImage
                    anchors.fill: parent
                    smooth: true

                    source: "pics/CalendarTodayButton12px.png"
                }

                MouseArea {
                    id: dateNavTodayMouseArea
                    anchors.fill: parent

                    onClicked: loadNow();
                }
            }

            Item {
                id: dateNavRight
                anchors.left: parent.left
                anchors.leftMargin: 28
                y: 4
                width: 12
                height: 12

                Image {
                    id: dateNavRightImage
                    anchors.fill: parent
                    smooth: true

                    source: "pics/CalendarNextButton12px.png"
                }

                MouseArea {
                    id: dateNavRightMouseArea
                    anchors.fill: parent

                    onClicked: {
//                        if (theMonth < 12) theMonth++
//                        else {
//                            theYear++;
//                            theMonth = 1;
//                        }
//                        console.debug("Month:" + theMonth + " Year:" + theYear)
//                        loadSelectedMonth();
                        if (displayMonth < 12) displayMonth++
                        else {
                            displayYear++;
                            displayMonth = 1;
                        }
//                        console.debug("Month:" + theMonth + " Year:" + theYear)
                        loadMonth(displayMonth, displayYear);
                    }
                }
            }


            Text {
                id: dateNavLabel
                anchors.right: parent.right
                anchors.left: parent.left
                anchors.leftMargin: 40
                anchors.top: parent.top
                height: 20

                color: "white"
                text: currentMonth + " " + currentYear
                //font.family: "Helvetica"
                font.family: "Arial"
                //font.pointSize: 11
                font.pixelSize: 11
                font.bold: true
                horizontalAlignment: Text.AlignRight
                verticalAlignment: Text.AlignVCenter
            }
        }

        Column {
            id: box; spacing: 8
            anchors { fill: parent; topMargin: 20; bottomMargin: 0; leftMargin: 6; rightMargin: 6 }

            Column {
                id: column; spacing: 2
                //anchors { fill: parent }

                property real h: ((box.height) / 6) - ((spacing * (6 - 1)) / 6) -1
                property real w: (box.width / 4) - ((spacing * (4 - 1)) / 4)

                Grid {
                    id: grid; rows: 7; columns: 7; spacing: 0
                    //anchors { fill: parent }

                    property real w: (box.width / columns) - ((spacing * (columns - 1)) / columns)

                    XAQMLDatePickerButton { id: xlwd1; width: grid.w; height: column.h; font.bold:true; enabled: false; buttonMode: false }
                    XAQMLDatePickerButton { id: xlwd2; width: grid.w; height: column.h; font.bold:true; enabled: false; buttonMode: false }
                    XAQMLDatePickerButton { id: xlwd3; width: grid.w; height: column.h; font.bold:true; enabled: false; buttonMode: false }
                    XAQMLDatePickerButton { id: xlwd4; width: grid.w; height: column.h; font.bold:true; enabled: false; buttonMode: false }
                    XAQMLDatePickerButton { id: xlwd5; width: grid.w; height: column.h; font.bold:true; enabled: false; buttonMode: false }
                    XAQMLDatePickerButton { id: xlwd6; width: grid.w; height: column.h; font.bold:true; enabled: false; buttonMode: false }
                    XAQMLDatePickerButton { id: xlwd7; width: grid.w; height: column.h; font.bold:true; enabled: false; buttonMode: false }

                    XAQMLDatePickerButton { id: xld01; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld02; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld03; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld04; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld05; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld06; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld07; width: grid.w; height: column.h; }

                    XAQMLDatePickerButton { id: xld11; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld12; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld13; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld14; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld15; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld16; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld17; width: grid.w; height: column.h; }

                    XAQMLDatePickerButton { id: xld21; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld22; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld23; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld24; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld25; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld26; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld27; width: grid.w; height: column.h; }

                    XAQMLDatePickerButton { id: xld31; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld32; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld33; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld34; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld35; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld36; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld37; width: grid.w; height: column.h; }

                    XAQMLDatePickerButton { id: xld41; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld42; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld43; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld44; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld45; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld46; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld47; width: grid.w; height: column.h; }

                    XAQMLDatePickerButton { id: xld51; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld52; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld53; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld54; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld55; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld56; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld57; width: grid.w; height: column.h; }
                }
            }
        }

    }

    XAHDivisionLine {
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 225
        anchors.left:  parent.left
    }

    Rectangle {
        id: timePickerFrame
        anchors.left: parent.left
        anchors.leftMargin: 21
        anchors.right: parent.right
        anchors.rightMargin: 20
        anchors.top: parent.top
        anchors.topMargin: 230
        height: 130

        color: "transparent"

        Rectangle {
            id: xaTimePicker
            anchors.fill: parent
            color: "transparent"

            property bool enabled: true

            Grid {
                id: timePickerGridAM; rows: 2; columns: 6; spacing: 0
                anchors { fill: parent; topMargin: 0 }
                height: grid.w * 2

                XAQMLDatePickerButton { id: xlt01; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt02; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt03; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt04; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt05; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt06; width: grid.w; height: column.h; }

                XAQMLDatePickerButton { id: xlt11; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt12; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt13; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt14; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt15; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt16; width: grid.w; height: column.h; }
            }

            Text {
                id: timePickerAMLabel
                anchors.right: parent.right
                anchors.rightMargin: 5
                anchors.top: timePickerGridAM.top
                width: 25
                height: column.h * 2

                color: "white"
                font.family: "Arial"
                font.pixelSize: 11
                font.bold: false
                horizontalAlignment: Text.AlignLeft
                verticalAlignment: Text.AlignVCenter

                text: "AM"
            }

            Grid {
                id: timePickerGridPM; rows: 2; columns: 6; spacing: 0
                anchors { fill: parent; topMargin: 50 }
                height: grid.w * 2

                XAQMLDatePickerButton { id: xlt21; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt22; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt23; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt24; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt25; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt26; width: grid.w; height: column.h; }

                XAQMLDatePickerButton { id: xlt31; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt32; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt33; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt34; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt35; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlt36; width: grid.w; height: column.h; }
            }

            Text {
                id: timePickerPMLabel
                anchors.right: parent.right
                anchors.rightMargin: 5
                anchors.top: timePickerGridPM.top
                width: 25
                height: column.h * 2

                color: "white"
                font.family: "Arial"
                font.pixelSize: 11
                font.bold: false
                horizontalAlignment: Text.AlignLeft
                verticalAlignment: Text.AlignVCenter

                text: "PM"
            }

            Grid {
                id: timePickerGridMinutes; rows: 2; columns: 6; spacing: 0
                anchors { fill: parent; topMargin: 100 }
                height: grid.w * 2

                XAQMLDatePickerButton { id: xlm01; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlm02; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlm03; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlm04; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlm05; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlm06; width: grid.w; height: column.h; }

                XAQMLDatePickerButton { id: xlm11; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlm12; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlm13; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlm14; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlm15; width: grid.w; height: column.h; }
                XAQMLDatePickerButton { id: xlm16; width: grid.w; height: column.h; }
            }

            Text {
                id: timePickerMinutesLabel
                anchors.right: parent.right
                anchors.rightMargin: 5
                anchors.top: timePickerGridMinutes.top
                width: 25
                height: column.h * 2

                color: "white"
                font.family: "Arial"
                font.pixelSize: 11
                font.bold: false
                horizontalAlignment: Text.AlignLeft
                verticalAlignment: Text.AlignVCenter

                text: "Min"
            }
        }

        Component.onCompleted: buildClock();
    }



}
